$(function(){
	//获取系统当前时间+5min的时间
	function getCurrentTime(){
		var currentTime = '';
		$.ajax({
			url:"/systemMsg/do_getNowDateTime",
			type:'get',
			async:false,
			success:function(data){
				 if( data.success ){
					 currentTime = data.data;
				 }else{
					 new $.zui.Messager('获取当前系统时间失败:'+ data.msg, {
						type: 'danger'
					 }).show();
				 }
			},
			error:function(status){
				new $.zui.Messager('获取当前系统时间时发生错误:'+status, {
				    type: 'danger'
				}).show();	
			}
		})
		return currentTime
	};
	
	//初始化选择日期
	function setDate(startDate){
		$(".form-date").datetimepicker(
			{
				weekStart: 1,
			    autoclose: 1,
			    todayHighlight: 0,
			    startView: 2,
			    forceParse: 0,
			    showMeridian: 1,
			    minuteStep:5,
			    startDate:startDate,
			    endDate:'2116-12-31',
			    format: "yyyy-mm-dd hh:ii"
			}
		);
		$(".form-date").datetimepicker('setStartDate',startDate)
	};
	
	//选择发送类型
	$(".sendType").click(function(){
		if( $("#sendType").data("sendType") != $(this).attr('value') ){
			$("#sendType").find('.text').text($(this).text()).end().data('sendType',$(this).attr("value"));
			if( $(this).attr('value')=='timing' ){
				setDate(getCurrentTime())
				$(".pushTimeBox").show();
			}else{
				$(".pushTimeBox").find('#pushTime').val('').end().hide();
			}
		}
	});
	$(".sendType").eq(0).click();
	
	//选择发送范围(选择部门和成员)
	$(".sendArea").unbind("click").bind("click",function(){
		chooseDepartOrPerson({
			dialogId:'.myModal-sendRange',//弹框的选择器
			chooseSure:'.chooseSure',//弹框确认按钮的选择器
			saveResultBox:'.sendArea',//点确定后存放选择结果的容器的选择器
			ajaxurl:'/org/findOrgAndUserTreeNodeAndAdmin',//获取包括超管在内的部门和人员
			atLeastOne:true,//是否需要至少选择一个部门或成员, 默认为false
			chooseDepart:true,//是否选择部门
			choosePerson:true//是否选择人员
		})
	});
	
	//发送时间有值时去掉验证效果
	$("#pushTime").change(function(){
		if( $("#pushTime").val()!='' ){
			$("#pushTime").removeClass('error');
			$("#pushTime-error").hide();
		}
	});
	
	//发送
	function addMessage(e){ 
		$("#addMessage").validate({
			 promptPosition : "bottomLeft",
			 submitHandler : function(form) {
				if( $('.myModal-sendRange').find(".rightAlreadyCheck .yk_check_list_item").length<=0 ){
					new $.zui.Messager('请选择发送范围', {
					    type: 'danger'
					 }).show();
					return;
				};
				var successTip = '发送成功'; 
				var addMessagePostData = {};
				addMessagePostData.title = $("#title").val();
				//发送范围处理, 先把部门和成员区分开
				var sendTypeDeparts = [],sendTypeUsers = []
				for(var i=0; i<$(".sendArea span").length;i++){
					if( $(".sendArea span").eq(i).attr('type') == 'icon icon-user' ){//成员
						sendTypeUsers.push({
							'id':$(".sendArea span").eq(i).attr('dataid')
						})
					}else{//部门
						sendTypeDeparts.push({
							'id':$(".sendArea span").eq(i).attr('dataid')
						})
					};
				};
				i = null;
				for( var i=0;i<sendTypeDeparts.length;i++ ){
					addMessagePostData['departmentList['+i+']'] = sendTypeDeparts[i].id;
				};
				i = null;
				for( var i=0;i<sendTypeUsers.length;i++ ){
					addMessagePostData['userList['+i+'].id'] = sendTypeUsers[i].id;
				};
				i = null;
				addMessagePostData.sendType = $("#sendType").data('sendType');
				if( $("#sendType").data('sendType')=='timing' ){
					//定时则需发送时间 以及 再次判断选择的时间是否合理
					//实际时间+5min大于选择时间, 即请求到的时间大于选择的时间时, 给出提示 
					if( new Date(Date.parse(getCurrentTime().replace(/-/g,"/"))) > new Date(Date.parse($("#pushTime").val().replace(/-/g,"/"))) ){
						new $.zui.Messager('定时时间与当前时间的间隔需大于等于5分钟,请重新选择定时时间', {
						    type: 'danger'
						}).show();	
						return;
					}else{//选择的定时时间符合规则
						successTip = '新建成功,将于'+$("#pushTime").val()+'进行发送';
						addMessagePostData.pushTime = $("#pushTime").val()+':00';
					}
				}else{
					successTip = '发送成功';
				}
				addMessagePostData.content = $("#content").val();
				$.ajax({
					url:'/systemMsg/do_add',
					type:'post',
					data:addMessagePostData,
					success:function(data){
						if( data.success ){
							new $.zui.Messager(successTip, {
							    type: 'success'
							}).show();	
							$(".yk_rightcontent").load('/systemMsg/sentMsgList',function(){
								backTop('.yk_orgContent');
							});
							//刷新头部消息数量
							//getUnreadMessage();
						}else{
							new $.zui.Messager('新建消息失败:'+data.msg, {
							    type: 'danger'
							 }).show();	
						}
					},
					error:function(status){
						new $.zui.Messager('新建消息时发生错误:'+status, {
						    type: 'danger'
						 }).show();	
					}
				})
				
			}, 
			rules : {
				"title":{
					required:true,
					maxlength:25
				},
				"pushTime":{
					required:true
				},
				"content":{
					required:true,
					maxlength:1500
				}
				
			},
			messages : {
				"title":{
					required:"请输入消息标题",
					maxlength:'标题最多可输入25个字符'
				},
				"pushTime":{
					required:"请选择发送时间"
				},
				"content":{
					required:"请输入消息内容",
					maxlength:"内容最多可输入1500个字符"
				}
			} 
		}); 
	};
	
	//发送按钮
	$(".yk_addNewMsg .save").click(addMessage);
	
	//关闭按钮
	$(".yk_addNewMsg .btn-cancel,.newBackBtn").click(function(){
		$(".yk_rightcontent").load("/systemMsg/sentMsgList",function(){
			
		});
		return false;
	});
})
